function [sys,x0,str,ts] = spacemodel(t,x,u,flag)
switch flag,
case 0,
    [sys,x0,str,ts]=mdlInitializeSizes;
case 1,
    sys=mdlDerivatives(t,x,u);
case 3,
    sys=mdlOutputs(t,x,u);
case {2,4,9}
    sys=[];
otherwise
    error(['Unhandled flag = ',num2str(flag)]);
end

function [sys,x0,str,ts]=mdlInitializeSizes
global  m1 m2 L1  r1 r2 Fai g  %node c b 
% node=9;
% c=[-2 -1.5 -1 -0.5 0 0.5 1 1.5 2;
%    -2 -1.5 -1 -0.5 0 0.5 1 1.5 2];
% b=10;
Fai=2*eye(2);
mz=66;
Lz=1.70;
m1=0.2578*mz;
m2=0.0968*mz;
L1=0.10042*Lz;
L2=0.04651*Lz;
r1=0.386*L1;
r2=0.413*L2;
g=9.8;

sizes = simsizes;
sizes.NumContStates  = 2;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 2;
sizes.NumInputs      = 10;
sizes.DirFeedthrough = 1;
sizes.NumSampleTimes = 1;
sys = simsizes(sizes);

x0  = [0 0];
str = [];
ts  = [0 0];
% 
function sys=mdlDerivatives(t,x,u)
global  Fai   %node c b
qdh=u(1);
d_qdh=u(2);
dd_qdh=u(3);
qdk=u(3);
d_qdk=u(4);
dd_qdk=u(6);%Ƕ

qh=u(5);
d_qh=u(6);
qk=u(7);
d_qk=u(8);%ϵͳģŹؽںϥؽڽǶ

q=[qh;qk];

e1=qdh-qh; %ŹؽڵĽǶ
e2=qdk-qk; %ϥؽڵĽǶ
de1=d_qdh-d_qh;
de2=d_qdk-d_qk;
e=[e1;e2];
de=[de1;de2];
r=de+Fai*e;  %ģ

qd=[qdh;qdk];
dqd=[d_qdh;d_qdk];
% dqr=dqd+Fai*e;
ddqd=[dd_qdh;dd_qdk];
ddqr=ddqd+Fai*de;
sys(1)=qdh;
sys(2)=d_qdh;

function sys=mdlOutputs(t,x,u)
global  m1 m2 L1  r1 r2 Fai g  % node c b 
% node=9;
% c=[-2 -1.5 -1 -0.5 0 0.5 1 1.5 2;
%    -2 -1.5 -1 -0.5 0 0.5 1 1.5 2];
% b=10;
Fai=20*eye(2);
mz=66;
Lz=1.70;
m1=0.2578*mz;
m2=0.0968*mz;
L1=0.10042*Lz;
L2=0.04651*Lz;
r1=0.386*L1;
r2=0.413*L2;
g=9.8;

qdh=u(1);
d_qdh=u(2);
dd_qdh=u(3);
qdk=u(4);
d_qdk=u(5);
dd_qdk=u(6);%Ƕ

qh=u(7);
d_qh=u(8);
qk=u(9);
d_qk=u(10);%ϵͳģŹؽںϥؽڽǶ


e1=qdh-qh; %ŹؽڵĽǶ
e2=qdk-qk; %ϥؽڵĽǶ
de1=d_qdh-d_qh;
de2=d_qdk-d_qk;
e=[e1;e2];
de=[de1;de2];

Kd=[120 0;0 120];
Kp=[150 0;0 150];

tol=Kp*e+Kd*de;

sys(1)=tol(1);
sys(2)=tol(2);
