function [sys,x0,str,ts] = spacemodel(t,x,u,flag)
switch flag,
case 0,
    [sys,x0,str,ts]=mdlInitializeSizes;
case 1,
    sys=mdlDerivatives(t,x,u);
case 3,
    sys=mdlOutputs(t,x,u);
case {2,4,9}
    sys=[];
otherwise
    error(['Unhandled flag = ',num2str(flag)]);
end
function [sys,x0,str,ts]=mdlInitializeSizes
sizes = simsizes;
sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 6;
sizes.NumInputs      = 0;
sizes.DirFeedthrough = 0;
sizes.NumSampleTimes = 1;
sys = simsizes(sizes);
x0  = [];
str = [];
ts  = [0 0];
function sys=mdlOutputs(t,x,u)
  %left 腿的傅里叶拟合数据
% a0=-0.009267;a1=-0.04595;b1=0.1748;a2=-0.06813;b2=-0.1503;a3=-0.01644;b3= 0.03226;a4=-0.02581;b4=-0.01935;
% a5=-0.007497;b5=0.008891;a6=-0.002827;b6=0.01183;a7=-0.0002764;b7=0.004671;a8=-0.000678 ;b8=0.004246;w=4.098;

% aa0= -0.09931;aa1=0.359;bb1=0.01429;aa2=-0.2732;bb2=0.02332;aa3=0.1864;bb3= 0.06036;aa4=-0.0463 ;bb4=-0.03386;
% aa5=0.01274;bb5=0.02585;aa6=0.01644;bb6=0.01881 ;aa7=0.0002738 ;bb7=0.001367;aa8=-0.0002802;bb8=0.009369;ww=4.016;

     a0 =   -0.009267  ;
       a1 =    -0.04595  ;
       b1 =      0.1748 ;
       a2 =    -0.06813  ;
       b2 =     -0.1503 ;
       a3 =    -0.01644  ;
       b3 =     0.03226  ;
       a4 =    -0.02581  ;
       b4 =    -0.01935  ;
       a5 =   -0.007497 ;
       b5 =    0.008891  ;
       a6 =   -0.002827  ;
       b6 =     0.01183 ;
       a7 =  -0.0002764  ;
       b7 =    0.004671  ;
       a8 =   -0.000678  ;
       b8 =    0.004246  ;
       w =       4.098  ;
%        %right 腿的傅里叶拟合数据
%               a0 =     -0.5781 ;
%        a1 =     -0.3593  ;
%        b1 =       1.074  ;
%        a2 =        1.06  ;
%        b2 =      0.6389  ;
%        a3 =       0.659  ;
%        b3 =     -0.4386  ;
%        a4 =     -0.0914  ;
%        b4 =      -0.461  ;
%        a5 =     -0.3161  ;
%        b5 =    -0.02847  ;
%        a6 =    -0.09294  ;
%        b6 =      0.1501  ;
%        a7 =     0.04883  ;
%        b7 =     0.04772 ;
%        a8 =     0.01795  ;
%        b8 =   -0.002771  ;
%        w =       3.106  ;
       

qdh=a0+a1*cos(w*t)+b1*sin(w*t)+a2*cos(2*w*t)+b2*sin(2*w*t)+a3*cos(3*w*t)+b3*sin(3*w*t)+...
    +a4*cos(4*w*t)+b4*sin(4*w*t)+a5*cos(5*w*t)+b5*sin(5*w*t)+a6*cos(6*w*t)+b6*sin(6*w*t)+...
    +a7*cos(7*w*t)+b7*sin(7*w*t)+a8*cos(8*w*t)+b8*sin(8*w*t);
d_qdh=-a1*w*sin(w*t)+b1*w*cos(w*t)-2*w*a2*sin(2*w*t)+2*w*b2*cos(2*w*t)-3*w*a3*sin(3*w*t)+3*w*b3*cos(3*w*t)+...
    -4*w*a4*sin(4*w*t)+4*w*b4*cos(4*w*t)-5*w*a5*sin(5*w*t)+5*w*b5*cos(5*w*t)-6*w*a6*sin(6*w*t)+6*w*b6*cos(6*w*t)+...
    -7*w*a7*sin(7*w*t)+7*w*b7*cos(7*w*t)-8*w*a8*sin(8*w*t)+8*w*b8*cos(8*w*t);
dd_qdh=-a1*w*w*cos(w*t)-b1*w*w*sin(w*t)-4*w*w*a2*cos(2*w*t)-4*w*w*b2*sin(2*w*t)-9*w*w*a3*cos(3*w*t)-9*w*w*b3*sin(3*w*t)+...
    -16*w*w*a4*cos(4*w*t)-16*w*w*b4*sin(4*w*t)-25*w*w*a5*cos(5*w*t)-25*w*w*b5*sin(5*w*t)-36*w*w*a6*cos(6*w*t)-36*w*w*b6*sin(6*w*t)+...
    -49*w*w*a7*cos(7*w*t)-49*w*w*b7*sin(7*w*t)-64*w*w*a8*cos(8*w*t)-64*w*w*b8*sin(8*w*t);
%left 腿的傅里叶拟合数据
       a0 =    -0.09931  ;
       a1 =       0.359  ;
       b1 =     0.01429  ;
       a2 =     -0.2732  ;
       b2 =     0.02332 ;
       a3 =      0.1864  ;
       b3 =     0.06036  ;
       a4 =     -0.0463  ;
       b4 =    -0.03386  ;
       a5 =     0.01274  ;
       b5 =     0.02585  ;
       a6 =     0.01644  ;
       b6 =     0.01881  ;
       a7 =   0.0002738  ;
       b7 =    0.001367  ;
       a8 =  -0.0002802  ;
       b8 =    0.009369  ;
       w =       4.016  ;
%          %right 腿的傅里叶拟合数据
%        a0 =     -0.3137 ;
%        a1 =     -0.2587  ;
%        b1 =    -0.02592 ;
%        a2 =      0.2295  ;
%        b2 =    -0.03156  ;
%        a3 =      0.3406  ;
%        b3 =     0.02906  ;
%        a4 =     0.01952  ;
%        b4 =     0.01563  ;
%        a5 =    -0.02991  ;
%        b5 =    -0.05373  ;
%        a6 =    0.002202 ;
%        b6 =    0.004772  ;
%        a7 =    -0.01132  ;
%        b7 =     0.00755  ;
%        a8 =   -0.005041 ;
%        b8 =   -0.002132  ;
%        w =       4.023  ;

qdk=a0+a1*cos(w*t)+b1*sin(w*t)+a2*cos(2*w*t)+b2*sin(2*w*t)+a3*cos(3*w*t)+b3*sin(3*w*t)+...
    +a4*cos(4*w*t)+b4*sin(4*w*t)+a5*cos(5*w*t)+b5*sin(5*w*t)+a6*cos(6*w*t)+b6*sin(6*w*t)+...
    +a7*cos(7*w*t)+b7*sin(7*w*t)+a8*cos(8*w*t)+b8*sin(8*w*t);
d_qdk=-a1*w*sin(w*t)+b1*w*cos(w*t)-2*w*a2*sin(2*w*t)+2*w*b2*cos(2*w*t)-3*w*a3*sin(3*w*t)+3*w*b3*cos(3*w*t)+...
    -4*w*a4*sin(4*w*t)+4*w*b4*cos(4*w*t)-5*w*a5*sin(5*w*t)+5*w*b5*cos(5*w*t)-6*w*a6*sin(6*w*t)+6*w*b6*cos(6*w*t)+...
    -7*w*a7*sin(7*w*t)+7*w*b7*cos(7*w*t)-8*w*a8*sin(8*w*t)+8*w*b8*cos(8*w*t);
dd_qdk=-a1*w*w*cos(w*t)-b1*w*w*sin(w*t)-4*w*w*a2*cos(2*w*t)-4*w*w*b2*sin(2*w*t)-9*w*w*a3*cos(3*w*t)-9*w*w*b3*sin(3*w*t)+...
    -16*w*w*a4*cos(4*w*t)-16*w*w*b4*sin(4*w*t)-25*w*w*a5*cos(5*w*t)-25*w*w*b5*sin(5*w*t)-36*w*w*a6*cos(6*w*t)-36*w*w*b6*sin(6*w*t)+...
    -49*w*w*a7*cos(7*w*t)-49*w*w*b7*sin(7*w*t)-64*w*w*a8*cos(8*w*t)-64*w*w*b8*sin(8*w*t);
% qdk=aa0+aa1*cos(ww*t)+bb1*sin(ww*t)+aa2*cos(2*ww*t)+bb2*sin(2*ww*t)+aa3*cos(3*ww*t)+bb3*sin(3*ww*t)+...
%     +aa4*cos(4*ww*t)+bb4*sin(4*ww*t)+aa5*cos(5*ww*t)+bb5*sin(5*ww*t)+aa6*cos(6*ww*t)+bb6*sin(6*ww*t)+...
%     +aa7*cos(7*ww*t)+bb7*sin(7*ww*t)+aa8*cos(8*ww*t)+bb8*sin(8*ww*t);
% d_qdk=-ww*aa1*sin(ww*t)+ww*bb1*cos(ww*t)-2*ww*aa2*sin(2*ww*t)+2*ww*bb2*cos(2*ww*t)-3*ww*aa3*sin(3*ww*t)+3*ww*bb3*cos(3*ww*t)+...
%     -4*ww*aa4*sin(4*ww*t)+4*ww*bb4*cos(4*ww*t)-5*ww*aa5*sin(5*ww*t)+5*ww*bb5*cos(5*ww*t)-6*ww*aa6*sin(6*ww*t)+6*ww*bb6*cos(6*ww*t)+...
%     -7*ww*aa7*sin(7*ww*t)+7*ww*bb7*cos(7*ww*t)-8*ww*aa8*sin(8*ww*t)+8*ww*bb8*cos(8*ww*t);
% dd_qdk=-ww*ww*aa1*cos(ww*t)-ww*ww*bb1*sin(ww*t)-4*ww*ww*aa2*cos(2*ww*t)-4*ww*ww*bb2*sin(2*ww*t)-9*ww*ww*aa3*cos(3*ww*t)-9*ww*ww*bb3*sin(3*ww*t)+...
%     -16*ww*ww*aa4*cos(4*ww*t)-16*ww*ww*bb4*sin(4*ww*t)-25*ww*ww*aa5*cos(5*ww*t)-25*ww*ww*bb5*sin(5*ww*t)-36*ww*ww*aa6*cos(6*ww*t)-36*ww*ww*bb6*sin(6*ww*t)+...
%     -49*ww*ww*aa7*cos(7*ww*t)-49*ww*ww*bb7*sin(7*ww*t)-64*ww*ww*aa8*cos(8*ww*t)-64*ww*ww*bb8*sin(8*ww*t);





sys(1)=qdh;
sys(2)=d_qdh;
sys(3)=dd_qdh;
sys(4)=qdk;
sys(5)=d_qdk;
sys(6)=dd_qdk;