function [sys,x0,str,ts] = spacemodel(t,x,u,flag)
switch flag,
case 0,
    [sys,x0,str,ts]=mdlInitializeSizes;
case 1,
    sys=mdlDerivatives(t,x,u);
case 3,
    sys=mdlOutputs(t,x,u);
case {2,4,9}
    sys=[];
otherwise
    error(['Unhandled flag = ',num2str(flag)]);
end

function [sys,x0,str,ts]=mdlInitializeSizes
global  m1 m2 L1  r1 r2 Fai g  

Fai=2*eye(2);
mz=66;
Lz=1.70;
m1=0.2578*mz;
m2=0.0968*mz;
L1=0.10042*Lz;
L2=0.04651*Lz;
r1=0.386*L1;
r2=0.413*L2;
g=9.8;

sizes = simsizes;
sizes.NumContStates  = 2;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 2;
sizes.NumInputs      = 12;
sizes.DirFeedthrough = 1;
sizes.NumSampleTimes = 1;
sys = simsizes(sizes);

x0  = [0 0];
str = [];
ts  = [0 0];
% 
function sys=mdlDerivatives(t,x,u)

sys(1)=0;
sys(2)=0;

function sys=mdlOutputs(t,x,u)


qdh=u(1);
d_qdh=u(2);

qdk=u(4);
d_qdk=u(5);

qh=u(7);
d_qh=u(8);
qk=u(9);
d_qk=u(10);%ϵͳģŹؽںϥؽڽǶ
op_h=u(11);
op_k=u(12);
op=[op_h;op_k];


e1=qdh-qh; %ŹؽڵĽǶ
e2=qdk-qk; %ϥؽڵĽǶ
de1=d_qdh-d_qh;
de2=d_qdk-d_qk;
e=[e1;e2];
de=[de1;de2];

Kd=[120 0;0 120];
Kp=[150 0;0 150];

tol=Kp*e+Kd*de-op;

sys(1)=tol(1);
sys(2)=tol(2);