function [sys,x0,str,ts] = spacemodel(t,x,u,flag)
switch flag,
case 0,
    [sys,x0,str,ts]=mdlInitializeSizes;
case 1,
    sys=mdlDerivatives(t,x,u);
case 3,
    sys=mdlOutputs(t,x,u);
case {2,4,9}
    sys=[];
otherwise
    error(['Unhandled flag = ',num2str(flag)]);
end
function [sys,x0,str,ts]=mdlInitializeSizes
sizes = simsizes;
sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 6;
sizes.NumInputs      = 0;
sizes.DirFeedthrough = 0;
sizes.NumSampleTimes = 1;
sys = simsizes(sizes);
x0  = [];
str = [];
ts  = [0 0];
function sys=mdlOutputs(t,x,u)

%   % opensim出的left腿拟合数据
% a0=0.2096;a1=0.2929;b1=0.3276;a2=0.4109;b2=0.5137;a3= 0.3277;b3=0.07146;a4=0.2054;b4=-0.247;
% a5=-0.04189;b5=-0.1475;a6=-0.09755;b6=-0.03279 ;a7=-0.03554 ;b7=0.02184;a8=0.006773;b8=0.01568;w=3.45 ;
% 
% aa0=-17.66;aa1=22.58;bb1=-0.9172;aa2=-14.74;bb2=-1.461;aa3=11.8;bb3=0.0575;aa4=-5.538;bb4=-2.601;
% aa5=-0.2031;bb5=0.9945;aa6=-0.2246;bb6=1.305;aa7=-0.7124;bb7=0.6459;aa8=0.3031;bb8=0.8575;ww=3.976;

%opensim出的right腿拟合数据
% a0=25.62;a1=-4.256;b1=9.684;a2= -4.897;b2=-11.81;a3=-7.476;b3=-4.902;a4=-1.983;b4=-0.6185;
% a5=0.3351;b5= 0.6764;a6=-0.2586;b6= 0.06287;a7=-0.01581;b7=0.3207;a8=0.2589;b8=-0.05863;w= 3.917;

% aa0=-34.55;aa1= -13.91;bb1= -3.59;aa2=12.43;bb2= -1.142;aa3=19.04;bb3=4.066;aa4=2.398;bb4=0.8282;
% aa5=-1.647 ;bb5=-3.248;aa6= -0.7444;bb6=0.04134;aa7=-0.5668;bb7= 0.6447;aa8=-0.5384;bb8=0.1403;ww=4.086;
% opensim出的left腿拟合数据

     a0 =   -0.009267  ;
       a1 =    -0.04595  ;
       b1 =      0.1748 ;
       a2 =    -0.06813  ;
       b2 =     -0.1503 ;
       a3 =    -0.01644  ;
       b3 =     0.03226  ;
       a4 =    -0.02581  ;
       b4 =    -0.01935  ;
       a5 =   -0.007497 ;
       b5 =    0.008891  ;
       a6 =   -0.002827  ;
       b6 =     0.01183 ;
       a7 =  -0.0002764  ;
       b7 =    0.004671  ;
       a8 =   -0.000678  ;
       b8 =    0.004246  ;
       w =       4.098  ;
       
%    %  opensim出的right腿拟合数据  
%               a0 =      0.4471  ;
%        a1 =    -0.07463  ;
%        b1 =      0.1693  ;
%        a2 =    -0.08509  ;
%        b2 =     -0.2059  ;
%        a3 =     -0.1303  ;
%        b3 =    -0.08578  ;
%        a4 =    -0.03465  ;
%        b4 =    -0.01088  ;
%        a5 =    0.005788  ;
%        b5 =     0.01185  ;
%        a6 =   -0.004494  ;
%        b6 =    0.001064  ;
%        a7 =  -0.0003256  ;
%        b7 =     0.00558  ;
%        a8 =    0.004517  ;
%        b8 =  -0.0009876  ;
%        w =       3.918  ;

opensim_qdh=a0+a1*cos(w*t)+b1*sin(w*t)+a2*cos(2*w*t)+b2*sin(2*w*t)+a3*cos(3*w*t)+b3*sin(3*w*t)+...
    +a4*cos(4*w*t)+b4*sin(4*w*t)+a5*cos(5*w*t)+b5*sin(5*w*t)+a6*cos(6*w*t)+b6*sin(6*w*t)+...
    +a7*cos(7*w*t)+b7*sin(7*w*t)+a8*cos(8*w*t)+b8*sin(8*w*t);
opensim_d_qdh=-a1*w*sin(w*t)+b1*w*cos(w*t)-2*w*a2*sin(2*w*t)+2*w*b2*cos(2*w*t)-3*w*a3*sin(3*w*t)+3*w*b3*cos(3*w*t)+...
    -4*w*a4*sin(4*w*t)+4*w*b4*cos(4*w*t)-5*w*a5*sin(5*w*t)+5*w*b5*cos(5*w*t)-6*w*a6*sin(6*w*t)+6*w*b6*cos(6*w*t)+...
    -7*w*a7*sin(7*w*t)+7*w*b7*cos(7*w*t)-8*w*a8*sin(8*w*t)+8*w*b8*cos(8*w*t);
opensim_dd_qdh=-a1*w*w*cos(w*t)-b1*w*w*sin(w*t)-4*w*w*a2*cos(2*w*t)-4*w*w*b2*sin(2*w*t)-9*w*w*a3*cos(3*w*t)-9*w*w*b3*sin(3*w*t)+...
    -16*w*w*a4*cos(4*w*t)-16*w*w*b4*sin(4*w*t)-25*w*w*a5*cos(5*w*t)-25*w*w*b5*sin(5*w*t)-36*w*w*a6*cos(6*w*t)-36*w*w*b6*sin(6*w*t)+...
    -49*w*w*a7*cos(7*w*t)-49*w*w*b7*sin(7*w*t)-64*w*w*a8*cos(8*w*t)-64*w*w*b8*sin(8*w*t);
% opensim出的left腿拟合数据
       a0 =    -0.09931  ;
       a1 =       0.359  ;
       b1 =     0.01429  ;
       a2 =     -0.2732  ;
       b2 =     0.02332 ;
       a3 =      0.1864  ;
       b3 =     0.06036  ;
       a4 =     -0.0463  ;
       b4 =    -0.03386  ;
       a5 =     0.01274  ;
       b5 =     0.02585  ;
       a6 =     0.01644  ;
       b6 =     0.01881  ;
       a7 =   0.0002738  ;
       b7 =    0.001367  ;
       a8 =  -0.0002802  ;
       b8 =    0.009369  ;
       w =       4.016  ;
%      %  opensim出的right腿拟合数据  
%             a0 =      -0.603 ;
%        a1 =     -0.2429  ;
%        b1 =    -0.06272  ;
%        a2 =      0.2169  ;
%        b2 =    -0.01988  ;
%        a3 =      0.3323  ;
%        b3 =     0.07113  ;
%        a4 =     0.04191  ;
%        b4 =      0.0145  ;
%        a5 =    -0.02866  ;
%        b5 =    -0.05672  ;
%        a6 =    -0.01298  ;
%        b6 =   0.0006919 ;
%        a7 =   -0.009899  ;
%        b7 =     0.01124  ;
%        a8 =   -0.009399  ;
%        b8 =    0.002438  ;
%        w =       4.087  ;
       
       


opensim_qdk=a0+a1*cos(w*t)+b1*sin(w*t)+a2*cos(2*w*t)+b2*sin(2*w*t)+a3*cos(3*w*t)+b3*sin(3*w*t)+...
    +a4*cos(4*w*t)+b4*sin(4*w*t)+a5*cos(5*w*t)+b5*sin(5*w*t)+a6*cos(6*w*t)+b6*sin(6*w*t)+...
    +a7*cos(7*w*t)+b7*sin(7*w*t)+a8*cos(8*w*t)+b8*sin(8*w*t);
opensim_d_qdk=-a1*w*sin(w*t)+b1*w*cos(w*t)-2*w*a2*sin(2*w*t)+2*w*b2*cos(2*w*t)-3*w*a3*sin(3*w*t)+3*w*b3*cos(3*w*t)+...
    -4*w*a4*sin(4*w*t)+4*w*b4*cos(4*w*t)-5*w*a5*sin(5*w*t)+5*w*b5*cos(5*w*t)-6*w*a6*sin(6*w*t)+6*w*b6*cos(6*w*t)+...
    -7*w*a7*sin(7*w*t)+7*w*b7*cos(7*w*t)-8*w*a8*sin(8*w*t)+8*w*b8*cos(8*w*t);
opensim_dd_qdk=-a1*w*w*cos(w*t)-b1*w*w*sin(w*t)-4*w*w*a2*cos(2*w*t)-4*w*w*b2*sin(2*w*t)-9*w*w*a3*cos(3*w*t)-9*w*w*b3*sin(3*w*t)+...
    -16*w*w*a4*cos(4*w*t)-16*w*w*b4*sin(4*w*t)-25*w*w*a5*cos(5*w*t)-25*w*w*b5*sin(5*w*t)-36*w*w*a6*cos(6*w*t)-36*w*w*b6*sin(6*w*t)+...
    -49*w*w*a7*cos(7*w*t)-49*w*w*b7*sin(7*w*t)-64*w*w*a8*cos(8*w*t)-64*w*w*b8*sin(8*w*t);

% opensim_qdk=aa0+aa1*cos(ww*t)+bb1*sin(ww*t)+aa2*cos(2*ww*t)+bb2*sin(2*ww*t)+aa3*cos(3*ww*t)+bb3*sin(3*ww*t)+...
%     +aa4*cos(4*ww*t)+bb4*sin(4*ww*t)+aa5*cos(5*ww*t)+bb5*sin(5*ww*t)+aa6*cos(6*ww*t)+bb6*sin(6*ww*t)+...
%     +aa7*cos(7*ww*t)+bb7*sin(7*ww*t)+aa8*cos(8*ww*t)+bb8*sin(8*ww*t);
% opensim_d_qdk=-ww*aa1*sin(ww*t)+ww*bb1*cos(ww*t)-2*ww*aa2*sin(2*ww*t)+2*ww*bb2*cos(2*ww*t)-3*ww*aa3*sin(3*ww*t)+3*ww*bb3*cos(3*ww*t)+...
%     -4*ww*aa4*sin(4*ww*t)+4*ww*bb4*cos(4*ww*t)-5*ww*aa5*sin(5*ww*t)+5*ww*bb5*cos(5*ww*t)-6*ww*aa6*sin(6*ww*t)+6*ww*bb6*cos(6*ww*t)+...
%     -7*ww*aa7*sin(7*ww*t)+7*ww*bb7*cos(7*ww*t)-8*ww*aa8*sin(8*ww*t)+8*ww*bb8*cos(8*ww*t);
% opensim_dd_qdk=-ww*ww*aa1*cos(ww*t)-ww*ww*bb1*sin(ww*t)-4*ww*ww*aa2*cos(2*ww*t)-4*ww*ww*bb2*sin(2*ww*t)-9*ww*ww*aa3*cos(3*ww*t)-9*ww*ww*bb3*sin(3*ww*t)+...
%     -16*ww*ww*aa4*cos(4*ww*t)-16*ww*ww*bb4*sin(4*ww*t)-25*ww*ww*aa5*cos(5*ww*t)-25*ww*ww*bb5*sin(5*ww*t)-36*ww*ww*aa6*cos(6*ww*t)-36*ww*ww*bb6*sin(6*ww*t)+...
%     -49*ww*ww*aa7*cos(7*ww*t)-49*ww*ww*bb7*sin(7*ww*t)-64*ww*ww*aa8*cos(8*ww*t)-64*ww*ww*bb8*sin(8*ww*t);
sys(1)=opensim_qdh;
sys(2)=opensim_d_qdh;
sys(3)=opensim_dd_qdh;
sys(4)=opensim_qdk;
sys(5)=opensim_d_qdk;
sys(6)=opensim_dd_qdk;