function [sys,x0,str,ts]=s_function(t,x,u,flag)

switch flag,
case 0,
    [sys,x0,str,ts]=mdlInitializeSizes;
case 1,
    sys=mdlDerivatives(t,x,u);
case 3,
    sys=mdlOutputs(t,x,u);
case {2, 4, 9 }
    sys = [];
otherwise
    error(['Unhandled flag = ',num2str(flag)]);
end
function [sys,x0,str,ts]=mdlInitializeSizes
global  g m1 m2 L1 L2 r1 r2 mz Lz
sizes = simsizes;
sizes.NumContStates  = 4;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 4;
sizes.NumInputs      =4;
sizes.DirFeedthrough = 0;
sizes.NumSampleTimes = 0;
sys=simsizes(sizes);
x0=[0 0 0 0];
str=[];
ts=[];

g=9.8;
mz=66;
Lz=1.70;
m1=0.2578*mz;
m2=0.0968*mz;
L1=0.10042*Lz;
L2=0.04651*Lz;
r1=0.386*L1;
r2=0.413*L2;


function sys=mdlDerivatives(t,x,u)
global g m1 m2 L1  r1 r2 

M=[m1*r1*r1+m2*L1*L1+m2*r2*r2+2*m2*L1*r2*cos(x(3)) m2*r2*r2+m2*L1*r2*cos(x(3));
   m2*r2*r2+m2*L1*r2*cos(x(3))  m2*r2*r2];
C=[-2*m2*L1*r2*x(4)*sin(x(3)) -m2*L1*r2*x(4)*sin(x(3));
     m2*L1*r2*x(2)*sin(x(3))  0];
G=[m1*r1*g*sin(x(1))+m2*g*(L1*sin(x(1))+r2*sin(x(1)+x(3)));
    m2*r2*g*sin(x(3))];
dq=[x(2);x(4)];%输入角度q的一阶导和二阶导
told=0.5*sin(dq);
tol=[u(1)+u(3);u(2)+u(4)];%控制器输出的力矩
S=inv(M)*((tol-C*dq-G-told));%S是q的二阶导
sys(1)=x(2);
sys(2)=S(1);
sys(3)=x(4);
sys(4)=S(2);  %q的一阶导和二阶导
function sys=mdlOutputs(t,x,u)

sys(1)=x(1);
sys(2)=x(2);
sys(3)=x(3);
sys(4)=x(4);